<?php
/**
 * AYPHP v1.3 未经授权使用后果自负 -云青
 */

/* 
 
                       .::::. 
                     .::::::::. 
                    :::::::::::  I want to say... 
                ..:::::::::::' 
              '::::::::::::' 
                .:::::::::: 
           '::::::::::::::.. 
                ..::::::::::::. 
              ``:::::::::::::::: 
               ::::``:::::::::'        .:::. 
              ::::'   ':::::'       .::::::::. 
            .::::'      ::::     .:::::::'::::. 
           .:::'       :::::  .:::::::::' ':::::. 
          .::'        :::::.:::::::::'      ':::::. 
         .::'         ::::::::::::::'         ``::::. 
     ...:::           ::::::::::::'              ``::. 
    ```` ':.          ':::::::::'                  ::::.. 
                       '.:::::'                    ':'````.. 
 
 
*/  

final class Ay {

	//框架启动
	public static function run() {
		self::safe();
		self::setReporting();
		set_error_handler(array(__CLASS__,'error'));
		register_shutdown_function(array(__CLASS__,'fatal_error'));
		self::set_const();		
		self::create_dir();
		self::import_file();
		self::user_impot_file();
		self::removeMagicQuotes();
        self::unregisterGlobals();
		Core::run();
	}

	//定义常量
	private static function set_const() {
		$path = str_replace('\\','/',__FILE__);
		defined('AY') or define('AY',dirname($path));
		defined('ROOT') or define('ROOT',dirname(AY));		
		defined('COMMON') or define('COMMON',AY.'/common');
		defined('CONFIG') or define('CONFIG',AY.'/config');
		defined('CORE') or define('CORE',AY.'/core');
		defined('LIB') or define('LIB',CORE.'/lib');
		defined('DRIVE') or define('DRIVE',AY.'/drive');
		defined('LOG') or define('LOG',DRIVE.'/log');
		defined('ERROR') or define('ERROR', AY.'/error');
		defined('VENDOR') or define('VENDOR',AY.'/vendor');
		defined('VERSION') or define('VERSION','1.2');
		define("IS_POST", ($_SERVER['REQUEST_METHOD'] == 'POST')?true:false);
		define("IS_GET", ($_SERVER['REQUEST_METHOD'] == 'GET')?true:false);

		if (isset($_SERVER['HTTP_X_REQUESTED_WITH']) and $_SERVER['HTTP_X_REQUESTED_WITH'] == 'XMLHttpREquest') {
			define('IS_AJAX', true);
		} else {
			define('IS_AJAX', false);
		}

		//app目录常量
		defined('APP_PATH') or define('APP_PATH', ROOT.APP_NAME);
		defined('APP_VIEW') or define('APP_VIEW', APP_PATH.'/Views');
		defined('APP_CONTROLLER') or define('APP_CONTROLLER', APP_PATH.'/Controllers');
		defined('APP_CONFIG') or define('APP_CONFIG', APP_PATH.'/Configs');
		defined('APP_COMMON') or define('APP_COMMON',APP_PATH.'/Commons');
		defined('APP_MODEL') or define('APP_MODEL', APP_PATH.'/Models');
		defined('APP_PUBLIC') or define('APP_PUBLIC',APP_PATH.'/Public');
		defined('APP_TEMP') or define('APP_TEMP',APP_PATH.'/Temp');
		defined('APP_COMPILE') or define('APP_COMPILE',APP_TEMP.'/'.APP_NAME);
		defined('APP_CACHE') or define('APP_CACHE',APP_TEMP.'/'.APP_NAME.'/cache');

		define('__PUBLIC__',APP_PUBLIC);

	}

	//自动创建用户目录
	private static function create_dir() {
		$file = array(
			APP_PATH,
			APP_MODEL,
			APP_CONFIG,
			APP_CONTROLLER,
			APP_VIEW,
			APP_PUBLIC,
			APP_COMMON,
			APP_COMPILE,
			APP_CACHE
		);
		foreach ($file as $value) {
			is_dir($value) || mkdir($value,0777,true);
		}	
		
	}

	//导入框架所需文件
	private static function import_file() {
		$file = array(
			COMMON.'/function.php',
			DRIVE.'/smarty/Smarty.class.php',
			LIB.'/SmartyView.php',
			LIB.'/Config.php',
			DRIVE.'/Log.php',
			LIB.'/Route.php',
			CORE.'/Controller.php',	
			LIB.'/Medoo.php',
			LIB.'/Model.php',
			CORE.'/Core.php'
		);
		foreach ($file as $value) {
			include_once $value;
		}
	}

	//导入用户文件
	private static function user_impot_file() {
		$file = Config::get_file('AUTO_LOAD_FILE','config');
		if (is_array($file) and !empty($file)) {
			foreach ($file as $value) {
				include_once APP_COMMON.'/'.$value;
			}
		}
	}

	//调试模式
	private static function setReporting() {
		if (!APP_DEBUG) {
            error_reporting(E_ALL);
            ini_set('display_errors','off');
        } else {
            error_reporting(E_ALL);
            ini_set('display_errors','Off');
        }
	}

	//普通错误追踪
	public static function error($errno,$error,$file,$line) {
		switch ($errno) {
			case E_ERROR:
			case E_PARSE:
			case E_CORE_ERROR:
			case E_COMPILE_ERROR:
			case E_USER_ERROR:
				$msg = $error.$file."第{$line}行";
				halt($msg);
			break;

			case E_STRICT:
			case E_USER_WARNING:
			case E_USER_NOTICE:
			default:
				if (APP_DEBUG) {
					include ERROR.'/notice.html';
				}
				break;
		}
	}

	//致命错误追踪
	public static function fatal_error() {
		if ($e = error_get_last()) {
			self::error($e['type'],$e['message'],$e['file'],$e['line']);
		}
	}

	//框架安全
	private static function safe() {
		if (APP_SAFE) {
			empty($_SERVER['HTTP_VIA']) or exit('Access Denied');
			session_start();
			$seconds = '3';
			$refresh = '5';
			$cur_time = time();
			if (isset($_SESSION['last_time'])) {
 				$_SESSION['refresh_times'] += 1;
			} else {
 				$_SESSION['refresh_times'] = 1;
 				$_SESSION['last_time'] = $cur_time;
			}

			if ($cur_time - $_SESSION['last_time'] < $seconds) {
	 			if ($_SESSION['refresh_times'] >= $refresh) {
					header(sprintf('Location:%s', 'http://127.0.0.1'));
  					exit('Access Denied');
 				}
			} else {
 				$_SESSION['refresh_times'] = 0;
 				$_SESSION['last_time'] = $cur_time;
			}
		}
	}

	// 删除敏感字符
    private static function stripSlashesDeep($value) {
        $value = is_array($value) ? array_map(array($this, 'stripSlashesDeep'), $value) : stripslashes($value);
        return $value;
    }

    // 检测敏感字符并删除
    private static function removeMagicQuotes() {
        if (get_magic_quotes_gpc()) {
            $_GET = isset($_GET) ? self::stripSlashesDeep($_GET ) : '';
            $_POST = isset($_POST) ? self::stripSlashesDeep($_POST ) : '';
            $_COOKIE = isset($_COOKIE) ? self::stripSlashesDeep($_COOKIE) : '';
            $_SESSION = isset($_SESSION) ? self::stripSlashesDeep($_SESSION) : '';
        }
    }

	// 检测自定义全局变量并移除
    private static function unregisterGlobals() {
        if (ini_get('register_globals')) {
            $array = array('_SESSION', '_POST', '_GET', '_COOKIE', '_REQUEST', '_SERVER', '_ENV', '_FILES');
            foreach ($array as $value) {
                foreach ($GLOBALS[$value] as $key => $var) {
                    if ($var === $GLOBALS[$key]) {
                        unset($GLOBALS[$key]);
                    }
                }
            }
        }
    }	
}

AY::run();
?>
