<?php
/**
 * 控制器类
 */


/* 
 
                       .::::. 
                     .::::::::. 
                    :::::::::::  I want to say... 
                ..:::::::::::' 
              '::::::::::::' 
                .:::::::::: 
           '::::::::::::::.. 
                ..::::::::::::. 
              ``:::::::::::::::: 
               ::::``:::::::::'        .:::. 
              ::::'   ':::::'       .::::::::. 
            .::::'      ::::     .:::::::'::::. 
           .:::'       :::::  .:::::::::' ':::::. 
          .::'        :::::.:::::::::'      ':::::. 
         .::'         ::::::::::::::'         ``::::. 
     ...:::           ::::::::::::'              ``::. 
    ```` ':.          ':::::::::'                  ::::.. 
                       '.:::::'                    ':'````.. 
 
 
*/  

if(!defined('ROOT')){exit('No direct script access allowed');}
                       
class Controller extends SmartyView {

	//[name] 参数名
	//[safe] 默认开启
	protected function request($name,$safe = 1) {
		if (!isset($_REQUEST[$name])) {
			return false;
		}
		$return = $_REQUEST[$name];
		if (!empty($return)) {
			if ($safe == 1) {
    			return $this -> daddslashes($return);
			} else {
				return $return;
			}
		} else {
			return false;
		}
	}


	//GET取参数
	//[name] 参数名
	//[safe] 默认开启
	public static $var_key;
	protected function get($name,$safe = 1) {
		$route = new Route();
		if (!empty($route -> get)  and isset($route -> get)) {
			$var = $route -> get;
			//print_r($var);
			foreach ($var as $key => $value) {
				if($value == $name){
					self::$var_key = $key + 1;
					break;
				}	
			}
			$vae = self::$var_key;
			if (isset($var[$vae]) and !empty($var[$vae])) {
				$data = $var[$vae];
			} else {
				return false;
			}
			
			if ($safe == 1) {
    			$data = $this -> daddslashes($data);
			}
			return $data;
		} else {
			return false;
		}
		
	}

	//POST取参数
	//[name] 参数名
	//[safe] 默认开启
	protected function post($name,$safe = 1) {
		
		if (!isset($_POST[$name])) {
			return false;
		}
		$return = $_POST[$name];
		if (!empty($return)) {
			if ($safe == 1) {
    			return $this -> daddslashes($return);
			} else {
				return $return;
			}
		} else {
			return false;
		}
		
	}

	//字符安全过滤
	protected function daddslashes($string, $force = 0, $strip = FALSE) {
  		!defined('MAGIC_QUOTES_GPC') && define('MAGIC_QUOTES_GPC', get_magic_quotes_gpc());
  		if(!MAGIC_QUOTES_GPC || $force) {
     		if(is_array($string)) {
        		foreach($string as $key => $val) {
			        $string[$key] = daddslashes($val, $force, $strip);
	        	}
     		} else {
			    $string = addslashes($strip ? stripslashes($string) : $string);
	     	}
    	}
    	return $string;
	}

	//显示模板
	//[filename] 文件名
	//[data] 数组
	protected function view($filename,$data = NULL,$aaa = NULL) {
		if (Config::get_file('SMARTY_ON','config')) {
			if (!is_null($data) and is_array($data)) {
				foreach ($data as $key => $value) {
					parent::view($aaa,$key,$value);
				}
			}
			parent::view($filename);
			return;
		}
		ob_start();
		if (!is_null($data) and is_array($data)) {
			extract($data);
		} else if (!is_array($data) and isset($data)){
			halt(Config::get_file('data','error'));
			exit;
		}
		
		$suffix = strchr($filename,'.');
		$file_path = empty($suffix)?APP_VIEW.'/'.$filename.'.html':APP_VIEW.'/'.$filename;
		if (is_file($file_path)) {
			include $file_path;
			echo trim(ob_get_clean());
		} else {
			halt(Config::get_file('notfound','error'));

		}
		
	}

	//加载模型
	//[filename] 文件名
	//[start] 默认初始化类
	protected function model($filename,$start = NULL) {
		$file_path = APP_MODEL.'/'.$filename.'Model.php';
		if (is_file($file_path)) {
			include_once $file_path;
			if (is_null($start)) {
				$name = $filename.'Model';
				$filename = new $name();
				return $filename;
			}
		} else {
			halt(Config::get_file('notfound','error'));
		}
	}

	//设置session
	//[name] 参数
	//[var] 赋值
	protected function set_session($name,$var = NULL) {
		if (is_null($var)) {
			$_SESSION[$name] = $name;
		} else {
			$_SESSION[$name] = $var;
		}
		
	}

	//判断session是否存在
	//[name] 参数
	//[var] 赋值
	protected function is_session($name,$var = NULL) {
		if(!isset($_SESSION[$name])){
    		return false;
		} else if($_SESSION[$name] == $var and !is_null($var)) {
			return true;
		} else {
			return true;
		}
	}

	//清除session
	//[name] 参数
	protected function unset_session($name) {
		//unset($_SESSION[$name]);
		session_unset($name);
		//session_destroy($name);		
	}

	//自动加载并初始化用户类
	//[filename]文件名
	//[start] 默认初始化类
	protected function C($filename,$start = NULL) {
		if (!empty($filename)) {
			$path = APP_COMMON.'/'.$filename.'.class.php';
			if (is_file($path)) {
				include_once $path;
				if (is_null($start)) {
					$filename = new $filename();
					return $filename;
				}
			} else {
				halt(Config::get_file('notfound','error'));
				
			}
		}
	}

	//自动加载并初始化系统类
	//[filename]文件名
	//[start] 默认初始化类
	private function R($filename,$start = NULL) {
		if (!empty($filename)) {
			$path = COMMON.'/'.$filename.'.class.php';
			if (is_file($path)) {
				include_once $path;
				if (is_null($start)) {
					$filename = new $filename();
					return $filename;
				}
			} else {
				halt(Config::get_file('notfound','error'));
				
			}
		}
	}

	//curl采集
	public function curl($url,$post = 0,$referer = 0,$cookie = 0,$header = 0,$ua = 0,$nobaody = 0) {
  		$ch = curl_init();
 		curl_setopt($ch, CURLOPT_URL,$url);
  		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
  		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
  		$httpheader[] = "Accept:*/*";
  		$httpheader[] = "Accept-Encoding:gzip,deflate,sdch";
  		$httpheader[] = "Accept-Language:zh-CN,zh;q=0.8";
  		$httpheader[] = "Connection:close";
  		curl_setopt($ch, CURLOPT_HTTPHEADER, $httpheader);
  		curl_setopt($ch, CURLOPT_TIMEOUT, 5);
  		if ($post) :
    		curl_setopt($ch, CURLOPT_POST, 1);
    		curl_setopt($ch, CURLOPT_POSTFIELDS, $post);
  		endif;
  		if ($header) :
    		curl_setopt($ch, CURLOPT_HEADER, TRUE);
  		endif;
  		if ($cookie) :
    		curl_setopt($ch, CURLOPT_COOKIE, $cookie);
  		endif;
  		if ($referer) :
    		if($referer == 1){
      			curl_setopt($ch, CURLOPT_REFERER, 'http://blog.aaayun.cc');
    		} else {
      			curl_setopt($ch, CURLOPT_REFERER, $referer);
    		}
  		endif;
  		if ($ua) {
    		curl_setopt($ch, CURLOPT_USERAGENT,$ua);
  		} else {
    		curl_setopt($ch, CURLOPT_USERAGENT,'Mozilla/5.0 (Linux; Android 4.4.2; NoxW Build/KOT49H) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/30.0.0.0 Mobile Safari/537.36');
  		}
  		if ($nobaody) :
    		curl_setopt($ch, CURLOPT_NOBODY,1);
 		endif;
  		curl_setopt($ch, CURLOPT_ENCODING, "gzip");
  		curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
  		$ret = curl_exec($ch);
  		curl_close($ch);
  		return $ret;
	}
    

    protected function mail($host,$port,$from,$pwd,$user,$to,$subject,$body,$type = 'TXT',$debug = false) {
    	$this -> R('Smtp',1);

		//这里面的一个true是表示使用身份验证,否则不使用身份验证. 
		$smtp = new Smtp($host,$port,true,$user,$pwd);
		//是否显示发送的调试信息 
		$smtp -> debug = $debug;
		//发送邮件
		$smtp -> SendMail($to, $from, $subject, $body, $type); 

    }

}

?>