<?php
/**
 * 核心类
 */

/* 
 
                       .::::. 
                     .::::::::. 
                    :::::::::::  I want to say... 
                ..:::::::::::' 
              '::::::::::::' 
                .:::::::::: 
           '::::::::::::::.. 
                ..::::::::::::. 
              ``:::::::::::::::: 
               ::::``:::::::::'        .:::. 
              ::::'   ':::::'       .::::::::. 
            .::::'      ::::     .:::::::'::::. 
           .:::'       :::::  .:::::::::' ':::::. 
          .::'        :::::.:::::::::'      ':::::. 
         .::'         ::::::::::::::'         ``::::. 
     ...:::           ::::::::::::'              ``::. 
    ```` ':.          ':::::::::'                  ::::.. 
                       '.:::::'                    ':'````.. 
 
 
*/  

if(!defined('ROOT')){exit('No direct script access allowed');}
                       
final class Core {
	public static $classMap = array();

	public static function run() {
		self::_init();
		// set_error_handler(array(__CLASS__,'error'));
		spl_autoload_register(array(__CLASS__,'_autoload'));
		self::route();
		

	}

	private static function route() {
		$route = new Route();
		$controllerClass = $route -> controller;
		$controller_class = $controllerClass;	
		$action = $route -> action;
		$CONTROLLER_DELIMITER = Config::get_file('CONTROLLER_DELIMITER','config');
		if (strpos($controllerClass,$CONTROLLER_DELIMITER)) {
			$controller_array = explode($CONTROLLER_DELIMITER,$controllerClass);
			$controller_ml = $controller_array[0];
			$controllerClass = $controller_array[1];
			$controllerfile = ROOT.APP_NAME.'/Controllers/'.$controller_ml.'/'.$controllerClass.'Controller.php';
		} else {
			$controllerfile = ROOT.APP_NAME.'/Controllers/'.$controllerClass.'Controller.php';
		}
		//组合类名
		$controllerClass = $controllerClass.'Controller';	
		if (is_file($controllerfile)) {
			//加载控制器			
			include_once $controllerfile;
			//实例化控制器
			$controller = new $controllerClass();
			if (is_callable(array($controller, $action))) {
				define('CONTROLLER', $controller_class);
				define('ACTION', $action);
				Log::visit($controller_class,$action);
				$controller -> $action();
			} else {
				halt(Config::get_file('action','error'));
			}		
		} else {
			halt(Config::get_file('controller','error'));
			exit;
		}				
	}
	
	//自动加载
	private static function _autoload($class) {
		if (isset($claseeMap['$class'])) {
			return true;
		} else {
			$class = str_replace('\\','/',$class);
			$file = APP_CONTROLLER.'/'.$class.'.php';
			if (is_file($file)) {
				include $file;
				self::$classMap['$class'] = $class;
			} else {
				return false;
			}
		}
	}

	private static function _init() {

		//设置默认时区
		date_default_timezone_set(Config::get_file('DEFAULT_TIME_ZONE','config'));

		@header('Content-Type: text/html; charset=UTF-8');
		
		//是否开启session
		if (Config::get_file('SESSION_AUTO_START','config') and !session_id()) session_start();

	}

	public static function error($errno,$error,$file,$line) {
		switch ($errno) {
			case E_STRICT:
			case E_USER_WARNING:
			case E_USER_NOTICE:
			default:
				if (APP_DEBUG) {
					include ERROR.'/notice.html';
				}
				break;
		}
	}

}

?>